---
layout: markdown_page
title: "Category Strategy - Geo-replication"
---

- TOC
{:toc}

## 🌏 Geo-replication

### Introduction and how you can help

| | |
| --- | --- |
| Maturity | [<%= data.categories["geo_replication"].maturity.capitalize %>](/direction/maturity/) |

<!-- A good description of what your category is. If there are
special considerations for your strategy or how you plan to prioritize, the
description is a great place to include it. Please include usecases, personas, 
and user journeys into this section. -->

* [Overall Strategy](/direction/geo)
* [Roadmap for <%= data.categories["geo_replication"].maturity %> maturity](https://gitlab.com/groups/gitlab-org/-/roadmap?label_name%5B%5D=group%3A%3Ageo&label_name%5B%5D=maturity%3A%3Aviable&scope=all&sort=start_date_asc&state=opened&utf8=%E2%9C%93)
* [Maturity: <%= data.categories["geo_replication"].maturity.capitalize %>](/direction/maturity/)
* [Documentation](https://docs.gitlab.com/ee/administration/geo/replication/)
* [All Epics](https://gitlab.com/groups/gitlab-org/-/epics?scope=all&utf8=%E2%9C%93&state=opened&label_name[]=Geo)

The Geo-replication category helps our users bring their data closer. Geo-replication provides an easily configurable, read-only mirror (we call it a Geo node) of a GitLab installation that is complete, accurate, verifiable and efficient.

Please reach out to Fabian Zimmer, Product Manager for the Geo group ([Email](mailto:fzimmer@gitlab.com)) if you'd like to provide feedback or ask any questions related to this product category.

This strategy is a work in progress, and everyone can contribute:

 - Please comment and contribute in the linked [issues](https://gitlab.com/groups/gitlab-org/-/issues?scope=all&utf8=%E2%9C%93&state=opened&label_name[]=Geo) and [epics](https://gitlab.com/groups/gitlab-org/-/epics?scope=all&utf8=%E2%9C%93&state=opened&label_name[]=Geo) on this page. Sharing your feedback directly on GitLab.com is the best way to contribute to our strategy and vision.

### 🔭 Where we are Headed  

At GitLab, [we want everyone to contribute](https://about.gitlab.com/company/strategy/#mission). Our goal for Geo-replication is to offer the same experience to users, independent of where they are located. Currently, Geo-replication requires a significant investment to be configured, upgraded and maintained by systems administrators. Not all parts of GitLab are replicated and there is not as much control over what is replicated where. In the future, we want our users to be able to configure Geo within minutes - not hours. We envision Geo-replication to be fully transparent to users. This means that a developer should not need to actively decide to use Geo, or select the right Geo node - GitLab should be able to determine what Geo node should be used to get the best performance. For systems adminstrators, it should be simple to add, configure and remove new nodes. Geo will allow distributed teams to collaborate across the globe sharing the same user experience wherever they are located.

* Pulls and clones of git repositories should be fast everywhere - especially for large repositories. 
* Users should not be required to configure geo-replication manually - we should detect the best Geo node automatically.
* Geo-replication should allow fine-grained control over what is replicated where - not every project and repository needs to be shared.
* Geo-replication should be easy to set-up and configure - new Geo nodes should be added with minimal effort.
* Geo-replication should be fully transparent for users - ideally a user of GitLab does not even notice that they are using a Geo node.

### 🎭 Target Audience and Experience
<!-- An overview of the personas involved in this category. An overview 
of the evolving user journeys as the category progresses through minimal,
viable, complete and lovable maturity levels.-->

#### Sidney (Systems Administrator) - [Persona Description](https://about.gitlab.com/handbook/marketing/product-marketing/roles-personas/#sidney-systems-administrator)

* 🙂 **Minimal** - Sidney is able to configure the Geo-replication setup manually, most commonly used data types are replicated.
* 😊 **Viable** - Sidney is able to configure Geo-replication in a mostly automated fashion. Various Geo-replication tasks (status reports, maintenance etc.) can be performed using the GitLab UI. All customer releveant data types are replicated.
* 😁 **Complete** - Sidney can setup Geo in an automated and fast way (minutes, not hours). A dashboard provides an overview for all relevant Geo tasks.
* 😍 **Lovable** - Sidney can setup Geo in an automated and fast way and everything is configurable from the UI, all nodes appear writable.

For more information on how we use personas and roles at GitLab, please [click here](https://about.gitlab.com/handbook/marketing/product-marketing/roles-personas/).

###  🚀 What's next & why 
<!-- This is almost always sourced from the following sections, which describe top
priorities for a few stakeholders. This section must provide a link to an issue
or [epic](https://about.gitlab.com/handbook/product/#epics-for-a-single-iteration) for the MVC or first/next iteration in
the category.-->

#### Automatically choosing the best Geo node

We will [provide better instructions to our users](https://gitlab.com/gitlab-org/gitlab-ee/issues/12700) on how to configure Geo in such a way that only a single Git URL is needed. This may be achieved. through geo-aware DNS or loadbalancers. We will alos work with the UX department to understand if [the user experience of the **primary** web interfaces is sufficient](https://gitlab.com/gitlab-org/ux-research/issues/258). Based on this research we may be able to to decide if we still need to provision secondary web-interfaces to users or not.

#### Making Geo simpler to install

Installating Geo takes many manual steps and could be a lot simpler. We will start investing how we can accomplish bu we identified that a service discovery solution could have a huge benefit in helping administrators set up clusters of Geo nodes. We are currently working to [support Geo on Kubernetes](https://gitlab.com/groups/gitlab-org/-/epics/944)
to give us a greater understanding of this tool to help inform us as to the right direction to take with this proposal. We will [update the service discovery proposal](https://gitlab.com/gitlab-org/gitlab-ee/issues/8932) when Kubernetes support is complete.

#### Multi-mode Geo

Currently, Geo can only officially be operated in one mode - [Read-Only](#read-only) - where each Geo secondaries DB is in a read-only mode.  Customer feedback has indicated a desire for additional operational / running modes:

##### Read-Only

The existing mode for a secondary node.

##### Data-Only

Currently how Geo runs on GitLab.com, but further modifications could be made to remove redundant components for this mode to make
it a light-weight DR tool.

##### Writable

A new mode that we are exploring. We have two proof-of-concepts for the idea:

- [WIP: POC for allowing a Geo secondary to write to the primary's DB](https://gitlab.com/gitlab-org/gitlab-ee/merge_requests/9354)
- [WIP: Geo POC for proxying non-get requests to the primary](https://gitlab.com/gitlab-org/gitlab-ee/merge_requests/10309)

We are aware that there may be a paradigm shift required to achieve distributed writable nodes, and following our value of
iteration, these POC's are a first step in expanding how we think about the domain of writable nodes.

### What is Not Planned Right Now

We are currently not planning on moving away from Postgres as a backend database in favour of e.g CockroachDB or Google Spanner. This has implications for multi-mode Geo, but for now we will continue to support Postgres.

### Maturity Plan
<!-- It's important your users know where you're headed next. The maturity plan
section captures this by showing what's required to achieve the next level. The
section should follow this format: -->

This category is currently at the `viable` maturity level, and our next maturity target is `complete` (see our [definitions of maturity levels](/direction/maturity/#legend).

### 🏅 Competitive landscape
<!-- The top two or three competitors, and what the next one or two items we should
work on to displace the competitor at customers, ideally discovered through
[customer meetings](https://about.gitlab.com/handbook/product/#customer-meetings). We’re not aiming for feature parity
with competitors, and we’re not just looking at the features competitors talk
about, but we’re talking with customers about what they actually use, and
ultimately what they need.-->

The top competitors for Geo-replication are

- [GitHub Enterprise geo-replication](https://help.github.com/en/enterprise/2.17/admin/installation/about-geo-replication) 
- [Azure DevOps](https://azure.microsoft.com/en-in/services/devops/)
- [Bitbucket Smart Mirroring](https://confluence.atlassian.com/bitbucket/work-with-bitbucket-smart-mirroring-838427532.html)

#### Feature overview

| Feature  | GitHub  | AzureDevOps  | Bitbucket Smart Mirroring  | GitLab |
|---|---|---|---|---|
| Mirror repositories  | ✅  | ✅  | ✅  | ✅  | 
| Active-active replication  | ❌  | N/A  | ❌  | ❌ |
| Selective sync  | N/A  | N/A   | ✅  | ⚠️ |
| UI configuration  | ❌ |  ✅ | N/A  | ⚠️ |
| Kubernetes support  |  ❌ |   ❌ | ❌  | ❌ |
| Mirror docker registries  | ❌  |  N/A | ❌  | ⚠️ |
| LFS and file upload support  | ✅  | N/A   |  ✅  | ✅  |
| Automatic DNS   |  ✅ | ✅ | ❌  |  ❌ 
| GUI Dashboard   |  ✅ | ✅ | N/A  |  ✅  |
| Request proxying   |  ✅ | N/A | N/A  |  ⚠️   |

 ✅ Fully available  
 ⚠️ Partially available  
 ❌ Not available  
 N/A No information available  

Based on GitHub's feature set the top two items to work on may be:

* Automatic DNS resolution
* Request proxying

### Analyst landscape

We do need to engage with analysts more closely to understand the current landscape better.

### Top Customer Success/Sales issue(s)

* [https://gitlab.com/gitlab-org/gitlab-ee/issues/2870](https://gitlab.com/gitlab-org/gitlab-ee/issues/2870)
* [Active active git replication](https://gitlab.com/gitlab-org/gitlab-ee/issues/1381)

## 🎢 Top user issues
<!-- This is probably the top popular issue from the category (i.e. the one with the most
thumbs-up), but you may have a different item coming out of customer calls.-->

* [Category issues listed by popularity](https://gitlab.com/groups/gitlab-org/-/issues?label_name%5B%5D=Geo&scope=all&sort=popularity&state=opened&utf8=%E2%9C%93)

## 🦊 Top internal customer issues/epics  
<!-- These are sourced from internal customers wanting to [dogfood](https://about.gitlab.com/handbook/product/#dogfood-everything)
the product.-->

* [Geo for DR on GitLab.com](https://gitlab.com/groups/gitlab-com/gl-infra/-/epics/12)

## Top Strategy Item(s)

- [Geo: Automatically choose the Geo node for the best user experience](https://gitlab.com/groups/gitlab-org/-/epics/1466)
